# all files / ol/style/ style.js

98.91% Statements 91/92
89.29% Branches 25/28
100% Functions 17/17
98.91% Lines 91/92

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    3751×
    1×
    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    273×

    273×

    273×

    273×

    273×

    273×

    273×

    273×

    273×

    1×
    4×

    1×
    76×

    1×
    80×

    1×
    106×

    1×
    73×

    1×
    93×

    1×
    85×

    1×
    7×
    2×
    5×
    2×
    1×
    1×
    1×

    1×

    3×
    1×
    2×
    2×

    2×
    1×

    7×

    1×
    1×

    1×

    1×
    155×

    155×
    142×

    13×
    13×
    5×

    8×

    7×

    12×
    6×

    154×

    1×

    1×

    61×
    1×

    1×

    1×

    61×

    1×

    54×
    54×
    54×
    54×
    54×

    54×

    54×

    54×

    54×

    54×

    54×

    54×

    54×

    1×

    1×
    73×
    73×

     goog.provide('ol.style.GeometryFunction');
    goog.provide('ol.style.Style');
    goog.provide('ol.style.StyleFunction');
    goog.provide('ol.style.defaultGeometryFunction');

    goog.require('goog.asserts');
    goog.require('ol.geom.Geometry');
    goog.require('ol.geom.GeometryType');
    goog.require('ol.style.Circle');
    goog.require('ol.style.Fill');
    goog.require('ol.style.Image');
    goog.require('ol.style.Stroke');

    /**
     * @classdesc
     * Container for vector feature rendering styles. Any changes made to the style
     * or its children through `set*()` methods will not take effect until the
     * feature or layer that uses the style is re-rendered.
     *
     * @constructor
     * @param {olx.style.StyleOptions=} opt_options Style options.
     * @api
     */
    ol.style.Style = function(opt_options) {

      var options = opt_options || {};

      /**
       * @private
       * @type {string|ol.geom.Geometry|ol.style.GeometryFunction}
       */
      this.geometry_ = null;

      /**
       * @private
       * @type {!ol.style.GeometryFunction}
       */
      this.geometryFunction_ = ol.style.defaultGeometryFunction;

      Iif (options.geometry !== undefined) {
        this.setGeometry(options.geometry);
      }

      /**
       * @private
       * @type {ol.style.Fill}
       */
      this.fill_ = options.fill !== undefined ? options.fill : null;

      /**
       * @private
       * @type {ol.style.Image}
       */
      this.image_ = options.image !== undefined ? options.image : null;

      /**
       * @private
       * @type {ol.style.Stroke}
       */
      this.stroke_ = options.stroke !== undefined ? options.stroke : null;

      /**
       * @private
       * @type {ol.style.Text}
       */
      this.text_ = options.text !== undefined ? options.text : null;

      /**
       * @private
       * @type {number|undefined}
       */
      this.zIndex_ = options.zIndex;

    };

    /**
     * Get the geometry to be rendered.
     * @return {string|ol.geom.Geometry|ol.style.GeometryFunction}
     * Feature property or geometry or function that returns the geometry that will
     * be rendered with this style.
     * @api
     */
    ol.style.Style.prototype.getGeometry = function() {
      return this.geometry_;
    };

    /**
     * Get the function used to generate a geometry for rendering.
     * @return {!ol.style.GeometryFunction} Function that is called with a feature
     * and returns the geometry to render instead of the feature's geometry.
     * @api
     */
    ol.style.Style.prototype.getGeometryFunction = function() {
      return this.geometryFunction_;
    };

    /**
     * Get the fill style.
     * @return {ol.style.Fill} Fill style.
     * @api
     */
    ol.style.Style.prototype.getFill = function() {
      return this.fill_;
    };

    /**
     * Get the image style.
     * @return {ol.style.Image} Image style.
     * @api
     */
    ol.style.Style.prototype.getImage = function() {
      return this.image_;
    };

    /**
     * Get the stroke style.
     * @return {ol.style.Stroke} Stroke style.
     * @api
     */
    ol.style.Style.prototype.getStroke = function() {
      return this.stroke_;
    };

    /**
     * Get the text style.
     * @return {ol.style.Text} Text style.
     * @api
     */
    ol.style.Style.prototype.getText = function() {
      return this.text_;
    };

    /**
     * Get the z-index for the style.
     * @return {number|undefined} ZIndex.
     * @api
     */
    ol.style.Style.prototype.getZIndex = function() {
      return this.zIndex_;
    };

    /**
     * Set a geometry that is rendered instead of the feature's geometry.
     *
     * @param {string|ol.geom.Geometry|ol.style.GeometryFunction} geometry
     *     Feature property or geometry or function returning a geometry to render
     *     for this style.
     * @api
     */
    ol.style.Style.prototype.setGeometry = function(geometry) {
      if (goog.isFunction(geometry)) {
        this.geometryFunction_ = geometry;
      } else if (goog.isString(geometry)) {
        this.geometryFunction_ = function(feature) {
          var result = feature.get(geometry);
          Eif (result) {
            goog.asserts.assertInstanceof(result, ol.geom.Geometry,
                'feature geometry must be an ol.geom.Geometry instance');
          }
          return result;
        };
      } else if (!geometry) {
        this.geometryFunction_ = ol.style.defaultGeometryFunction;
      } else Eif (geometry !== undefined) {
        goog.asserts.assertInstanceof(geometry, ol.geom.Geometry,
            'geometry must be an ol.geom.Geometry instance');
        this.geometryFunction_ = function() {
          return geometry;
        };
      }
      this.geometry_ = geometry;
    };

    /**
     * Set the z-index.
     *
     * @param {number|undefined} zIndex ZIndex.
     * @api
     */
    ol.style.Style.prototype.setZIndex = function(zIndex) {
      this.zIndex_ = zIndex;
    };

    /**
     * A function that takes an {@link ol.Feature} and a `{number}` representing
     * the view's resolution. The function should return an array of
     * {@link ol.style.Style}. This way e.g. a vector layer can be styled.
     *
     * @typedef {function((ol.Feature|ol.render.Feature), number):
     *     Array.<ol.style.Style>}
     * @api
     */
    ol.style.StyleFunction;

    /**
     * Convert the provided object into a style function.  Functions passed through
     * unchanged.  Arrays of ol.style.Style or single style objects wrapped in a
     * new style function.
     * @param {ol.style.StyleFunction|Array.<ol.style.Style>|ol.style.Style} obj
     *     A style function, a single style, or an array of styles.
     * @return {ol.style.StyleFunction} A style function.
     */
    ol.style.createStyleFunction = function(obj) {
      var styleFunction;

      if (goog.isFunction(obj)) {
        styleFunction = obj;
      } else {
        /**
         * @type {Array.<ol.style.Style>}
         */
        var styles;
        if (goog.isArray(obj)) {
          styles = obj;
        } else {
          goog.asserts.assertInstanceof(obj, ol.style.Style,
              'obj geometry must be an ol.style.Style instance');
          styles = [obj];
        }
        styleFunction = function() {
          return styles;
        };
      }
      return styleFunction;
    };

    /**
     * @type {Array.<ol.style.Style>}
     * @private
     */
    ol.style.defaultStyle_ = null;

    /**
     * @param {ol.Feature|ol.render.Feature} feature Feature.
     * @param {number} resolution Resolution.
     * @return {Array.<ol.style.Style>} Style.
     */
    ol.style.defaultStyleFunction = function(feature, resolution) {
      // We don't use an immediately-invoked function
      // and a closure so we don't get an error at script evaluation time in
      // browsers that do not support Canvas. (ol.style.Circle does
      // canvas.getContext('2d') at construction time, which will cause an.error
      // in such browsers.)
      if (!ol.style.defaultStyle_) {
        var fill = new ol.style.Fill({
          color: 'rgba(255,255,255,0.4)'
        });
        var stroke = new ol.style.Stroke({
          color: '#3399CC',
          width: 1.25
        });
        ol.style.defaultStyle_ = [
          new ol.style.Style({
            image: new ol.style.Circle({
              fill: fill,
              stroke: stroke,
              radius: 5
            }),
            fill: fill,
            stroke: stroke
          })
        ];
      }
      return ol.style.defaultStyle_;
    };

    /**
     * Default styles for editing features.
     * @return {Object.<ol.geom.GeometryType, Array.<ol.style.Style>>} Styles
     */
    ol.style.createDefaultEditingStyles = function() {
      /** @type {Object.<ol.geom.GeometryType, Array.<ol.style.Style>>} */
      var styles = {};
      var white = [255, 255, 255, 1];
      var blue = [0, 153, 255, 1];
      var width = 3;
      styles[ol.geom.GeometryType.POLYGON] = [
        new ol.style.Style({
          fill: new ol.style.Fill({
            color: [255, 255, 255, 0.5]
          })
        })
      ];
      styles[ol.geom.GeometryType.MULTI_POLYGON] =
          styles[ol.geom.GeometryType.POLYGON];

      styles[ol.geom.GeometryType.LINE_STRING] = [
        new ol.style.Style({
          stroke: new ol.style.Stroke({
            color: white,
            width: width + 2
          })
        }),
        new ol.style.Style({
          stroke: new ol.style.Stroke({
            color: blue,
            width: width
          })
        })
      ];
      styles[ol.geom.GeometryType.MULTI_LINE_STRING] =
          styles[ol.geom.GeometryType.LINE_STRING];

      styles[ol.geom.GeometryType.CIRCLE] =
          styles[ol.geom.GeometryType.POLYGON].concat(
              styles[ol.geom.GeometryType.LINE_STRING]
          );

      styles[ol.geom.GeometryType.POINT] = [
        new ol.style.Style({
          image: new ol.style.Circle({
            radius: width * 2,
            fill: new ol.style.Fill({
              color: blue
            }),
            stroke: new ol.style.Stroke({
              color: white,
              width: width / 2
            })
          }),
          zIndex: Infinity
        })
      ];
      styles[ol.geom.GeometryType.MULTI_POINT] =
          styles[ol.geom.GeometryType.POINT];

      styles[ol.geom.GeometryType.GEOMETRY_COLLECTION] =
          styles[ol.geom.GeometryType.POLYGON].concat(
              styles[ol.geom.GeometryType.LINE_STRING],
              styles[ol.geom.GeometryType.POINT]
          );

      return styles;
    };

    /**
     * A function that takes an {@link ol.Feature} as argument and returns an
     * {@link ol.geom.Geometry} that will be rendered and styled for the feature.
     *
     * @typedef {function((ol.Feature|ol.render.Feature)):
     *     (ol.geom.Geometry|ol.render.Feature|undefined)}
     * @api
     */
    ol.style.GeometryFunction;

    /**
     * Function that is called with a feature and returns its default geometry.
     * @param {ol.Feature|ol.render.Feature} feature Feature to get the geometry
     *     for.
     * @return {ol.geom.Geometry|ol.render.Feature|undefined} Geometry to render.
     */
    ol.style.defaultGeometryFunction = function(feature) {
      goog.asserts.assert(feature, 'feature must not be null');
      return feature.getGeometry();
    };